"use strict";

{
	const C3=self.C3;
	C3.Behaviors.ppstudio_beh_fsm.Instance = class ppstudio_beh_fsm_Instance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties)
		{
			super(behInst);
			
			// Initialise object properties			
	
			this._state = "";
			this._prevstate = "";
			this._instance = this;

			if (properties)
			{
				this._state = properties[0];
			}
			
			// Opt-in to getting calls to Tick()
			//this._StartTicking();
		}

		Release()
		{
			super.Release();
		}
		
		SaveToJson()
		{
			return {
				"CurrentState":this._state,
				"PreviousState":this._prevstate
			};
		}

		LoadFromJson(o)
		{
			this._state = o["CurrentState"];
        	this._prevstate = o["PreviousState"];
		}
		/*
		Tick()
		{
			const dt = this._runtime.GetDt(this._inst);
			const wi = this._inst.GetWorldInfo();
			
			// ... code to run every tick for this behavior ...
		}
		*/
		GetDebuggerProperties(){
			let values = [{
				title:"FSM",
				properties:[
					{name: "Current State", value:this._state},
					{name: "Previous State", value: this._prevstate}
				]
			}];
			return values;
		}
	};
}